import { scope } from "../scope.js";
import { arkBuiltin } from "./builtin.js";
import { arkFormat } from "./format.js";
import { arkJs } from "./js.js";
import { arkNumber } from "./number.js";
import { arkParse } from "./parse.js";
import { arkPlatform } from "./platform.js";
import { arkString } from "./string.js";
import { arkTs } from "./ts.js";
import { arkTypedArray } from "./typedArray.js";
export const ambient = scope({
    ...arkTs.keywords,
    ...arkJs.keywords,
    ...arkPlatform.keywords,
    ...arkString.keywords,
    ...arkNumber.keywords,
    ...arkBuiltin.keywords,
    string: arkString.submodule,
    number: arkNumber.submodule,
    TypedArray: arkTypedArray.submodule,
    parse: arkParse.submodule,
    format: arkFormat.submodule
}, { prereducedAliases: true, ambient: true });
export const ark = ambient.export();
export const type = ambient.type;
export const generic = ambient.generic;
export const define = ambient.define;
export const declare = ambient.declare;
