import * as util from "@ark/util";
import { Hkt, type Digit, type Key } from "@ark/util";
import type { Module } from "../module.ts";
import type { Out } from "../ast.ts";
import "./ts.ts";
declare class liftArrayHkt extends Hkt<[element: unknown]> {
    body: util.liftArray<this[0]> extends infer lifted ? (In: this[0] | lifted) => Out<lifted> : never;
}
declare const liftArray: import("@ark/schema").GenericRoot<readonly [["element", unknown]], liftArrayHkt>;
declare class mergeHkt extends Hkt<[base: object, props: object]> {
    body: util.merge<this[0], this[1]>;
}
declare const merge: import("@ark/schema").GenericRoot<readonly [["base", object], ["props", object]], mergeHkt>;
export type NonNegativeIntegerString = `${Digit}` | (`${Exclude<Digit, 0>}${string}` & `${bigint}`);
export declare const arkBuiltin: {
    keywords: Module<arkBuiltin.keywords>;
};
export declare namespace arkBuiltin {
    interface keywords {
        key: Key;
        nonNegativeIntegerString: NonNegativeIntegerString;
        liftArray: typeof liftArray.t;
        merge: typeof merge.t;
    }
}
export {};
