import type { AtLeast, AtMost, DivisibleBy, number } from "../ast.ts";
import type { Module, Submodule } from "../module.ts";
/**
 * As per the ECMA-262 specification:
 * A time value supports a slightly smaller range of -8,640,000,000,000,000 to 8,640,000,000,000,000 milliseconds.
 *
 * @see https://262.ecma-international.org/15.0/index.html#sec-time-values-and-time-range
 */
export declare const epoch: import("@ark/schema").BaseRoot<import("@ark/schema").InternalRootDeclaration>;
export declare namespace arkNumber {
    interface keywords {
        integer: number.divisibleBy<1>;
    }
    interface $ extends keywords {
        $root: number;
        epoch: number.is<DivisibleBy<1> & AtMost<8640000000000000> & AtLeast<-8640000000000000>>;
    }
    type submodule = Submodule<$>;
}
export declare const arkNumber: {
    keywords: Module<arkNumber.keywords>;
    submodule: Module<arkNumber.submodule>;
};
