import type { string } from "../ast.ts";
import type { Module, Submodule } from "../module.ts";
import { arkIp } from "./utils/ip.ts";
import { arkUuid } from "./utils/uuid.ts";
export declare const arkString: {
    keywords: Module<arkString.keywords>;
    submodule: Module<arkString.submodule>;
};
export declare namespace arkString {
    interface keywords {
        creditCard: string.matching<"?">;
        email: string.matching<"?">;
        uuid: arkUuid.submodule;
        url: string.matching<"?">;
        semver: string.matching<"?">;
        ip: arkIp.submodule;
    }
    interface $ extends keywords {
        $root: string;
        alpha: string.matching<"?">;
        alphanumeric: string.matching<"?">;
        digits: string.matching<"?">;
        lower: string.matching<"?">;
        upper: string.matching<"?">;
        numeric: string.narrowed;
        integer: string.narrowed;
        iso8601: string.narrowed;
        epoch: string.narrowed;
    }
    type submodule = Submodule<$>;
}
