import { Hkt, type Key, type omit, type pick, type show } from "@ark/util";
import type { Module } from "../module.ts";
declare class RecordHkt extends Hkt<[Key, unknown]> {
    body: Record<this[0], this[1]>;
}
declare const Record: import("@ark/schema").GenericRoot<readonly [["K", Key], ["V", unknown]], RecordHkt>;
declare class PickHkt extends Hkt<[object, Key]> {
    body: pick<this[0], this[1] & keyof this[0]>;
}
declare const Pick: import("@ark/schema").GenericRoot<readonly [["T", object], ["K", Key]], PickHkt>;
declare class OmitHkt extends Hkt<[object, Key]> {
    body: omit<this[0], this[1] & keyof this[0]>;
}
declare const Omit: import("@ark/schema").GenericRoot<readonly [["T", object], ["K", Key]], OmitHkt>;
declare class PartialHkt extends Hkt<[object]> {
    body: show<Partial<this[0]>>;
}
declare const Partial: import("@ark/schema").GenericRoot<readonly [["T", object]], PartialHkt>;
declare class RequiredHkt extends Hkt<[object]> {
    body: show<Required<this[0]>>;
}
declare const Required: import("@ark/schema").GenericRoot<readonly [["T", object]], RequiredHkt>;
declare class ExcludeHkt extends Hkt<[unknown, unknown]> {
    body: Exclude<this[0], this[1]>;
}
declare const Exclude: import("@ark/schema").GenericRoot<readonly [["T", unknown], ["U", unknown]], ExcludeHkt>;
declare class ExtractHkt extends Hkt<[unknown, unknown]> {
    body: Extract<this[0], this[1]>;
}
declare const Extract: import("@ark/schema").GenericRoot<readonly [["T", unknown], ["U", unknown]], ExtractHkt>;
export declare const arkTs: {
    keywords: Module<arkTs.keywords>;
};
export declare namespace arkTs {
    interface keywords {
        any: any;
        bigint: bigint;
        boolean: boolean;
        false: false;
        never: never;
        null: null;
        number: number;
        object: object;
        string: string;
        symbol: symbol;
        true: true;
        unknown: unknown;
        undefined: undefined;
        Record: typeof Record.t;
        Pick: typeof Pick.t;
        Omit: typeof Omit.t;
        Exclude: typeof Exclude.t;
        Extract: typeof Extract.t;
        Partial: typeof Partial.t;
        Required: typeof Required.t;
    }
}
export {};
